#include <IRremote.h> //Version 2.2.3
int count = 0;
//Schalter
int schalter = 3;

//Infrarot Empfaenger
int IRpin = 2;
IRrecv IRreceiver(IRpin); //für die IR Übertragung
decode_results IRwert;

//Ultraschallsensoren trigger
int trigger = 12; //alle

//Ultraschallsensoren echo
int echo1 = 11; //links
int echo2 = 10; //mitte
int echo3 = 8;  //rechts
//Ultraschall Empfaenger dauer
long dauer1 = 0; //links
long dauer2 = 0; //mitte
long dauer3 = 0; //rechts
//Entfernung zum Hinderniss Ultraschallsensor
long entfernung1 = 0; //links
long entfernung2 = 0; //mitte
long entfernung3 = 0; //rechts
//Stepper Links
//int enableL = 9;
int stepL = 6;
int richtungL = 5;
//Stepper Rechts
//int enableR = 9;
int stepR = 4;
int richtungR = 7;

//Schrittanzahl Stepper
int stepCounter;

//code for 1. receiver:
int pingPin1 = A1;
int echoPin1 = A2;
long cm1 = 0;
//code for 2. receiver:
int pingPin2 = A3;
int echoPin2 = A4;
long cm2 = 0;

float differenz = 3000;

void onSignal() {
    
  if(count%2 == 0){ long duration1;
               pinMode(pingPin1, OUTPUT);
               digitalWrite(pingPin1, LOW);
               delayMicroseconds(2);
               digitalWrite(pingPin1, HIGH);
               delayMicroseconds(10);
               digitalWrite(pingPin1, LOW);
               pinMode(echoPin1, INPUT);
               duration1 = pulseIn(echoPin1, HIGH);
               cm1 = microsecondsToCentimeters(duration1);
               Serial.print(cm1);
               Serial.print("cm(1)");
               Serial.println();
               ++count;
               
  }
  if(count%2 == 1){long duration2;
               pinMode(pingPin2, OUTPUT);
               digitalWrite(pingPin2, LOW);
               delayMicroseconds(2);
               digitalWrite(pingPin2, HIGH);
               delayMicroseconds(10);
               digitalWrite(pingPin2, LOW);
               pinMode(echoPin2, INPUT);
               duration2 = pulseIn(echoPin2, HIGH);
               cm2 = microsecondsToCentimeters(duration2);
               Serial.print(cm2);
               Serial.print("cm(2)");
               Serial.println();
               ++count;
   }   
 differenz = cm1 - cm2;
}

int mode = 0;
void onSignalKnopf(){
  mode = 1;
}
 
long microsecondsToCentimeters(long microseconds) {
  return microseconds / 29 / 2;
}

long ultraschallAntiRausch (int trigger,int echo)
{
  long dauer = 0;
    //Anti Rauschstörung für Ultraschallsensoren
  digitalWrite(trigger, LOW); 
  delay(5);   
    //Sendet Ultraschallsignal
  digitalWrite(trigger, HIGH);
  delay(10);
    //Abschließen des Sendens
  digitalWrite(trigger, LOW);
    //Gemessene Zeit
  return dauer = pulseIn(echo, HIGH);
}

long ultraschallEntfernungsrechner (long dauer)
{
  return((dauer)/2) / 29.1; 
}

void ultraschallAlles ()
{
  dauer1 = ultraschallAntiRausch (trigger, echo1);
  dauer2 = ultraschallAntiRausch (trigger, echo2);
  dauer3 = ultraschallAntiRausch (trigger, echo3);  
      
    // Die Zeit in den Wegumrechnen (in cm)
  entfernung1 = ultraschallEntfernungsrechner(dauer1); 
  entfernung2 = ultraschallEntfernungsrechner(dauer2);
  entfernung3 = ultraschallEntfernungsrechner(dauer3);  

    //Ausgabe
  Serial.print(entfernung1); 
  Serial.println(" cm (Entfernung Sensor 1)");
  Serial.print(entfernung2); 
  Serial.println(" cm (Entfernung Sensor 2)");
  Serial.print(entfernung3); 
  Serial.println(" cm (Entfernung Sensor 3)");
}

void stepperVorwaerts (int steps)
{
  for(stepCounter = 0; stepCounter < steps; ++stepCounter)
  {
    // Vorwaerts
    digitalWrite(richtungL,LOW); 
    digitalWrite(richtungR, LOW);
 
    digitalWrite(stepL,LOW);
    digitalWrite(stepR, LOW);
      
    delayMicroseconds(1000);
      
    digitalWrite(stepL,HIGH);
    digitalWrite(stepR, HIGH);
      
    delayMicroseconds(1000);
  }
}

void stepperRueckwaerts (int steps)
{
  for(stepCounter = 0; stepCounter < steps; ++stepCounter)
        {
            // Rueckwerts
          digitalWrite(richtungL,HIGH); 
          digitalWrite(richtungR, HIGH);
 
          digitalWrite(stepL,LOW);
          digitalWrite(stepR, LOW);
      
          delayMicroseconds(1000);
      
          digitalWrite(stepL,HIGH);
          digitalWrite(stepR, HIGH);
      
          delayMicroseconds(1000);
        }
}

void stepperDrehenRechts (int steps)
{
    for(stepCounter = 0; stepCounter < steps; ++stepCounter)
        {
           // Drehen im Kreis
          digitalWrite(richtungL,LOW); 
          digitalWrite(richtungR, HIGH);
 
          digitalWrite(stepL,LOW);
          digitalWrite(stepR, LOW);
      
          delayMicroseconds(1000);
      
          digitalWrite(stepL,HIGH);
          digitalWrite(stepR, HIGH);
      
          delayMicroseconds(1000);
        }
}

void stepperDrehenLinks (int steps)
{
  for(stepCounter = 0; stepCounter < steps; ++stepCounter)
        {
            // Drehen im Kreis
          digitalWrite(richtungL,HIGH); 
          digitalWrite(richtungR, LOW);
 
          digitalWrite(stepL,LOW);
          digitalWrite(stepR, LOW);
      
          delayMicroseconds(1000);
      
          digitalWrite(stepL,HIGH);
          digitalWrite(stepR, HIGH);
      
          delayMicroseconds(1000);
        }
}

 

void setup() {
  Serial.begin(9600);                     
    //Ultraschallsensoren
  pinMode(trigger, OUTPUT);              
  pinMode(echo1, INPUT);                
  pinMode(echo2, INPUT);                
  pinMode(echo3, INPUT);     
  //Stepper Links
  //pinMode(enableL, OUTPUT); // Enable
  pinMode(stepL, OUTPUT); // Step
  pinMode(richtungL, OUTPUT); // Richtung
   //Stepper Rechts
  //pinMode(enableR, OUTPUT); // Enable
  pinMode(stepR, OUTPUT); // Step
  pinMode(richtungR, OUTPUT); // Richtung
 
  //digitalWrite(9,LOW);
  
  //IR Empfaenger
  pinMode(IRpin, INPUT);
  IRreceiver.enableIRIn();
  
  //code for the receiver:
  pinMode(pingPin1, OUTPUT);
  pinMode(pingPin2, OUTPUT);
  attachInterrupt(digitalPinToInterrupt(2), onSignal, RISING);
  attachInterrupt(digitalPinToInterrupt(3), onSignalKnopf, RISING);

  //Schalter
  pinMode(schalter, INPUT);
}
 

void loop() {
  
 //if(mode == 0){
   if(differenz < -10 && differenz > - 200){
    Serial.println("Links");
    ultraschallAlles ();
    if(cm1 < 100 && cm2 < 150){
       stepperDrehenLinks (50);
       stepperVorwaerts(25);
       stepperDrehenRechts (50);
    }else{    
          //Richtungsänderungen wenn zu nah am Hindernis
          if (entfernung1 < 30 && entfernung1 != 0)
          {
            stepperDrehenRechts (100);
            stepperVorwaerts(50);
            stepperDrehenLinks (100);
          }
          else if (entfernung2 < 30 && entfernung2 != 0)
          {
            stepperRueckwaerts (100);
            if (entfernung3 < 50 && entfernung3 != 0){
              stepperDrehenLinks (100);
              stepperVorwaerts(50);
              stepperDrehenRechts (100);
            }
            else if (entfernung1 < 50 && entfernung1 != 0){
              stepperDrehenRechts (100);
              stepperVorwaerts(50);
              stepperDrehenLinks (100);            
            }
          }
          else if (entfernung3 < 30 && entfernung3 != 0)
          {
            stepperDrehenLinks (100);
            stepperVorwaerts(50);
            stepperDrehenRechts (100);
                
          }else { stepperDrehenLinks (20); }
    }
    }
    else if(differenz > 10 && differenz < 200){
      Serial.println("Rechts");
      ultraschallAlles ();
    if(cm1 < 150 && cm2 < 100){
       stepperDrehenRechts (50);
       stepperVorwaerts(25);
       stepperDrehenLinks (50);
    }else{    
        //Richtungsänderungen wenn zu nah am Hindernis
          if (entfernung1 < 30 && entfernung1 != 0)
          {
            stepperDrehenRechts (100);
            stepperVorwaerts(50);
            stepperDrehenLinks (100);
          }
          else if (entfernung2 < 30 && entfernung2 != 0)
          {
            stepperRueckwaerts (100);
            if (entfernung3 < 50 && entfernung3 != 0){
              stepperDrehenLinks (100);
              stepperVorwaerts(50);
              stepperDrehenRechts (100);
            }
            else if (entfernung1 < 50 && entfernung1 != 0){
              stepperDrehenRechts (100);
              stepperVorwaerts(50);
              stepperDrehenLinks (100);            
            }
          }
          else if (entfernung3 < 30 && entfernung3 != 0)
          {
            stepperDrehenLinks (100);
            stepperVorwaerts(50);
            stepperDrehenRechts (100);
                
          }else { stepperDrehenRechts (20); }
    }
    }
    else if(differenz < 11 && differenz > - 11 && differenz != 0){
      Serial.println("Geradeaus");
      ultraschallAlles ();
    if(cm1 < 150 && cm2 < 150){
      stepperVorwaerts(50); 
    }else{
        //Richtungsänderungen wenn zu nah am Hindernis
          if (entfernung1 < 30 && entfernung1 != 0)
          {
            stepperDrehenRechts (100);
            stepperVorwaerts(50);
            stepperDrehenLinks (100);
          }
          else if (entfernung2 < 30 && entfernung2 != 0)
          {
            stepperRueckwaerts (100);
            if (entfernung3 < 50 && entfernung3 != 0){
              stepperDrehenLinks (100);
              stepperVorwaerts(50);
              stepperDrehenRechts (100);
            }
            else if (entfernung1 < 50 && entfernung1 != 0){
              stepperDrehenRechts (100);
              stepperVorwaerts(50);
              stepperDrehenLinks (100);            
            }
          }
          else if (entfernung3 < 30 && entfernung3 != 0)
          {
            stepperDrehenLinks (100);
            stepperVorwaerts(50);
            stepperDrehenRechts (100);
                
          }else { stepperVorwaerts (150); }
    }
    }
 //} 
  
          
   
  delay(1000);   
}
